/* hercscrl.c -- Full-screen Scroll functions for Hercules Graphics Adapter.
 *	Changable scrolling area (rows) implemented.
 *		Izumi Ohzawa, 2-16-90
 *		Izumi Ohzawa, 1-20-90  initial version.
 *
 *	Sigh.  I wish Borland BGI supported scrolling in graphics mode.
 *	This omission is really a serious flaw of the BGI stuff.
 *	EVEN the IBM BIOS supports it.  Why can't Borland?
 *	Anyway, I could use BIOS scroll for all other adapters (CGA,EGA,VGA).
 *	Alas, Hercules has no BIOS.  So, here it goes.
 *
 *	Again, this is in the public domain.  Use at your own risk.
 *------------------------------------------------------------------------- */

#include <graphics.h>
#include <stdio.h>
#include <mem.h>
#include <process.h>
#include <dos.h>
#include "kjis.h"

#define VRAM	0xB000		/* Hercules Video RAM segment */

static void far *dstptr;
static void far *srcptr;

/* Scroll area / Alloc'ed in scrnctl.c / Only Yul, Ybr are used */
extern int Xul, Yul;	/* upper-left -- starts at (0,0) */
extern int Xbr, Ybr;	/* bottom-right */

/* === Hercules graphics mode scroll.  Assumes 16-pixel line spaceing for Kanji */
void
Herc_Scroll_Up(void)
{
unsigned int i;
	for(i=0; i<4; i++)
	{
	    srcptr = MK_FP(VRAM, 8192*i+360*(Yul+1));
            dstptr = MK_FP(VRAM, 8192*i+360*Yul);
	    /* 16pix/4 * (Ybr-Yul) lines * 90 bytes */
	    movmem(srcptr, dstptr, (size_t)(360*(Ybr-Yul)));
	}
        /* delete bottom-most line of area (line Ybr) */
	i = PixelPerRow*Ybr;
        setfillstyle(SOLID_FILL, 0);
	bar(0, i, MaxX, i+15);
}

void
Herc_Scroll_Down(void)
{
int i;
	for(i=0; i<4; i++)
	{
	    dstptr = MK_FP(VRAM, 8192*i+360*(Yul+1));
            srcptr = MK_FP(VRAM, 8192*i+360*Yul);
	    /* 16pix/4 * (Ybr-Yul) lines * 90 bytes */
	    movmem(srcptr, dstptr, (size_t)(360*(Ybr-Yul)));
	}

        /* delete line Yul */
	i = PixelPerRow*Yul;	
        setfillstyle(SOLID_FILL, 0);
	bar(0, i, MaxX, i+15);
}


